## image-garden 0.1.1

=== Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki
VERSION = 0.1.1
DESTDIR ?=

prefix ?= /usr/local
exec_prefix ?= $(prefix)

bindir ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
includedir ?= $(prefix)/include
mandir ?= $(datarootdir)/man
man1dir ?= $(mandir)/man1

.PHONY: all
all:: image-garden.mk

.PHONY: clean
clean::
	rm -f image-garden.mk

.PHONY: install
install:: README.md image-garden image-garden.mk image-garden.1 $(if $(DESTDIR),| $(DESTDIR))
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -t $(DESTDIR)$(bindir) image-garden
	sed -i -e 's,INCLUDEDIR=\.,INCLUDEDIR=$(includedir),' -e 's,@VERSION@,$(VERSION),' $(DESTDIR)$(bindir)/image-garden
	install -m 755 -d $(DESTDIR)$(includedir)
	install -m 644 -t $(DESTDIR)$(includedir) image-garden.mk
	install -m 755 -d $(DESTDIR)$(datarootdir)
	install -m 755 -d $(DESTDIR)$(datarootdir)/doc
	install -m 755 -d $(DESTDIR)$(datarootdir)/doc/image-garden
	install -m 644 -t $(DESTDIR)$(datarootdir)/doc/image-garden README.md NEWS NEWS.license
	install -m 755 -d $(DESTDIR)$(man1dir)
	install -m 644 -t $(DESTDIR)$(man1dir) image-garden.1

image-garden.mk: $(wildcard mk/*.mk)
	cat $(sort $^)>$@

ifneq (,$(DESTDIR))
$(DESTDIR):
	mkdir -p $(DESTDIR)
endif

.PHONY: check
check: SHELLCHECK ?= $(or $(shell command -v shellcheck),$(error program shellcheck is required))
check: image-garden
	$(SHELLCHECK) $^

.PHONY: fmt
fmt: SHFMT ?= $(or $(shell command -v shfmt),$(error program shfmt is required))
fmt: image-garden
	$(SHFMT) -w $^

dist: image-garden-$(VERSION).tar.gz
image-garden-$(VERSION).tar.gz: Makefile image-garden image-garden.1 LICENSE LICENSES/Apache-2.0.txt REUSE.toml NEWS NEWS.license README.md $(wildcard mk/*.mk)
	tar --transform=s,^,image-garden-$(VERSION)/, -zcf $@ $^

=== spread-demo/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki

.PHONY:
check:
	for x in $$(spread -list :tests/smoke/uname); do spread "$$x"; done

=== debian/changelog ===
image-garden (0.1.1-2) unstable; urgency=medium

  * Point VCS fields to salsa

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 24 Jan 2025 13:18:14 +0000

image-garden (0.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1093218)

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 24 Jan 2025 12:06:33 +0000

=== debian/control ===
Source: image-garden
Maintainer: Zygmunt Krynicki <me@zygoon.pl>
Section: devel
Priority: optional
Standards-Version: 4.7.0
Homepage: https://gitlab.com/zygoon/image-garden
Vcs-Browser: https://salsa.debian.org/zyga-guest/image-garden
Vcs-Git: https://salsa.debian.org/zyga-guest/image-garden.git
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), shellcheck

Package: image-garden
Architecture: all
Depends: genisoimage,
         make,
         ovmf,
         qemu-efi-aarch64,
         qemu-system-arm,
         qemu-system-x86,
         qemu-utils,
         wget,
         whois,
         ${misc:Depends},
         ${shlibs:Depends}
Description: tool for creating test virtual machines
 Image Garden downloads, initializes and optionally operates virtual machine
 images for popular operating systems. All the systems are designed for
 testing and come configured with well-known username and password, usually
 matching the name of the system.

=== debian/tests/control ===
Tests: bookworm-amd64
Depends: @
Restrictions: allow-stderr, needs-internet
Architecture: amd64

## image-garden 0.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: Apache-2.0
 # SPDX-FileCopyrightText: Zygmunt Krynicki
-VERSION = 0.1.1
+VERSION = 0.2
 DESTDIR ?=
 
 prefix ?= /usr/local
@@ -55,3 +55,6 @@
 dist: image-garden-$(VERSION).tar.gz
 image-garden-$(VERSION).tar.gz: Makefile image-garden image-garden.1 LICENSE LICENSES/Apache-2.0.txt REUSE.toml NEWS NEWS.license README.md $(wildcard mk/*.mk)
 	tar --transform=s,^,image-garden-$(VERSION)/, -zcf $@ $^
+
+public/index.html: image-garden.1
+	mandoc -O style=image-garden.css -T html ./$< >$@

=== debian/changelog ===
image-garden (0.2-2) unstable; urgency=medium

  * Import upstream patch that fixes support for qemu 10 (Closes: #1104067)
  * Depend on ca-certificates

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 25 Apr 2025 09:14:50 +0000

image-garden (0.2-1) unstable; urgency=medium

  * Bump standards-version to 4.7.2
  * New upstream version 0.2

 -- Zygmunt Krynicki <me@zygoon.pl>  Wed, 19 Mar 2025 07:42:31 +0000

image-garden (0.1.1-3) unstable; urgency=medium

  * Clarify copyright for files in debian/

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 17 Mar 2025 20:23:07 +0000

=== debian/rules ===
#!/usr/bin/make -f
export prefix=/usr

%:
	dh $@

## image-garden 0.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: Apache-2.0
 # SPDX-FileCopyrightText: Zygmunt Krynicki
-VERSION = 0.2
+VERSION = 0.3
 DESTDIR ?=
 
 prefix ?= /usr/local
@@ -24,7 +24,11 @@
 install:: README.md image-garden image-garden.mk image-garden.1 $(if $(DESTDIR),| $(DESTDIR))
 	install -m 755 -d $(DESTDIR)$(bindir)
 	install -m 755 -t $(DESTDIR)$(bindir) image-garden
-	sed -i -e 's,INCLUDEDIR=\.,INCLUDEDIR=$(includedir),' -e 's,@VERSION@,$(VERSION),' $(DESTDIR)$(bindir)/image-garden
+	sed -i \
+		-e 's,INCLUDEDIR=\.,INCLUDEDIR=$(includedir),' \
+		-e 's,@PREFIX@,$(prefix),' \
+		-e 's,@VERSION@,$(VERSION),' \
+		$(DESTDIR)$(bindir)/image-garden
 	install -m 755 -d $(DESTDIR)$(includedir)
 	install -m 644 -t $(DESTDIR)$(includedir) image-garden.mk
 	install -m 755 -d $(DESTDIR)$(datarootdir)

=== spread-demo/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki

SYSTEMS = $(sort $(shell spread -list :tests/smoke/uname | cut -d : -f 2))

.PHONY:
$(foreach s,$(SYSTEMS),spread-$s): spread-%:
	$(strip spread $(if $(filter-out ubuntu-core-%,$*),-artifacts artifacts) garden:$*:)

.PHONY:
check: $(foreach s,$(SYSTEMS),spread-$s)

=== debian/changelog ===
image-garden (0.3-1) unstable; urgency=medium

  * New upstream version 0.3
  * drop patches: applied upstream

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 08 May 2025 11:40:35 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Zygmunt Krynicki <me@zygoon.pl>
 Section: devel
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://gitlab.com/zygoon/image-garden
 Vcs-Browser: https://salsa.debian.org/zyga-guest/image-garden
 Vcs-Git: https://salsa.debian.org/zyga-guest/image-garden.git
@@ -11,7 +11,8 @@
 
 Package: image-garden
 Architecture: all
-Depends: genisoimage,
+Depends: ca-certificates,
+         genisoimage,
          make,
          ovmf,
          qemu-efi-aarch64,

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/zygoon/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate

## image-garden 0.4.2

=== Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki
VERSION = 0.4.2
DESTDIR ?=

prefix ?= /usr/local
exec_prefix ?= $(prefix)

bindir ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
includedir ?= $(prefix)/include
mandir ?= $(datarootdir)/man
man1dir ?= $(mandir)/man1

.PHONY: all
all:: image-garden.mk

.PHONY: clean
clean::
	rm -f image-garden.mk
	rm -f data/050-*.gen.mk

.PHONY: install
install:: README.md image-garden image-garden.mk image-garden.1 $(if $(DESTDIR),| $(DESTDIR))
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -t $(DESTDIR)$(bindir) image-garden
	sed -i \
		-e 's,@PREFIX@,$(prefix),' \
		-e 's,@VERSION@,$(VERSION),' \
		$(DESTDIR)$(bindir)/image-garden
	install -m 755 -d $(DESTDIR)$(includedir)
	install -m 644 -t $(DESTDIR)$(includedir) image-garden.mk
	install -m 755 -d $(DESTDIR)$(datarootdir)
	install -m 755 -d $(DESTDIR)$(datarootdir)/doc
	install -m 755 -d $(DESTDIR)$(datarootdir)/doc/image-garden
	install -m 644 -t $(DESTDIR)$(datarootdir)/doc/image-garden README.md NEWS NEWS.snappy NEWS.docker NEWS.license NEWS.snappy.license NEWS.docker.license
	install -m 755 -d $(DESTDIR)$(man1dir)
	install -m 644 -t $(DESTDIR)$(man1dir) image-garden.1

image-garden.mk: $(wildcard mk/*.mk) $(foreach n,$(wildcard data/*.ini),data/050-$(basename $(notdir $n)).gen.mk)
	cat $(patsubst mk/050-%.gen.mk,data/050-%.gen.mk,$(sort $(patsubst data/%,mk/%,$^))) >$@
	touch --reference=`stat $^ -c '%Y %n' | sort -nr | cut -d ' ' -f 2 | head -n 1` $@

ifneq (,$(DESTDIR))
$(DESTDIR):
	mkdir -p $(DESTDIR)
endif

data/050-%.gen.mk: rulegen.py data/%.ini
	./$< $(wordlist 2,$(words $^),$^) >$@

.PHONY: check check-sh check-py
check: check-sh check-py

FILES_SH = $(wildcard image-garden \
	spread-chooser/spread-chooser \
	snap/hooks/configure snap/hooks/install snap/hooks/post-refresh \
	qemu-stubs/qemu-system-x86_64 qemu-stubs/qemu-system-aarch64 qemu-stubs/qemu-system-riscv64 qemu-stubs/qemu-system-s390x qemu-stubs/qemu-system-ppc64 qemu-stubs/qemu-component-symlinks qemu-stubs/qemu-var-tmp)

FILES_PY = rulegen.py

check-sh: SHELLCHECK ?= $(or $(shell command -v shellcheck),$(error program shellcheck is required))
check-sh: $(FILES_SH)
	$(SHELLCHECK) $^

check-py: MYPY ?= $(or $(shell command -v mypy),$(error program mypy is required))
check-py: MYPY_FLAGS ?= --strict
check-py: $(FILES_PY)
	$(MYPY) $(MYPY_FLAGS) $^

.PHONY: fmt fmt-sh fmt-py
fmt: fmt-sh fmt-py

fmt-sh: SHFMT ?= $(or $(shell command -v shfmt),$(error program shfmt is required))
fmt-sh: $(FILES_SH)
	$(SHFMT) -w $^

fmt-py: BLACK ?= $(or $(shell command -v black),$(error program black is required))
fmt-py: $(FILES_PY)
	$(BLACK) $^

dist: image-garden-$(VERSION).tar.gz
image-garden-$(VERSION).tar.gz: Makefile image-garden image-garden.1 LICENSE LICENSES/Apache-2.0.txt REUSE.toml NEWS NEWS.snappy NEWS.docker NEWS.license NEWS.snappy.license NEWS.docker.license README.md rulegen.py $(wildcard data/*.ini) data/README.md
	tar --transform=s,^,image-garden-$(VERSION)/, -zcf $@ $^

public/index.html: image-garden.1
	mandoc -O style=image-garden.css -T html ./$< >$@

XDG_CACHE_HOME ?= $(HOME)/.cache

.PHONY: docker-test-smoke docker-test-all
docker-test-smoke:
	docker build -t image-garden:latest .
	docker run \
	    $(if $(wildcard /dev/kvm),--device /dev/kvm) \
	    --volume $(XDG_CACHE_HOME)/image-garden:/var/cache/image-garden \
	    --rm \
	    image-garden:latest \
	    ldd /usr/local/bin/qemu-img /usr/local/bin/qemu-system-x86_64 /usr/local/bin/qemu-system-aarch64 /usr/local/bin/qemu-system-riscv64 /usr/local/bin/qemu-system-s390x
	docker run \
	    $(if $(wildcard /dev/kvm),--device /dev/kvm) \
	    --volume $(XDG_CACHE_HOME)/image-garden:/var/cache/image-garden \
	    --rm \
	    image-garden:latest \
	    image-garden news
	docker run \
	    $(if $(wildcard /dev/kvm),--device /dev/kvm) \
	    --volume $(XDG_CACHE_HOME)/image-garden:/var/cache/image-garden \
	    --rm \
	    image-garden:latest \
	    image-garden make -C /tmp ubuntu-cloud-24.04.$(shell uname -m).run

docker-test-all:
	docker build -t image-garden:latest .
	docker run \
	    $(if $(wildcard /dev/kvm),--device /dev/kvm) \
	    --volume $(XDG_CACHE_HOME)/image-garden:/var/cache/image-garden \
	    --rm \
	    image-garden:latest \
	    image-garden make -C /tmp all -k

=== proxy/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki
DESTDIR ?=

prefix ?= /usr/local
exec_prefix ?= $(prefix)

sysconfdir ?= $(prefix)/etc
bindir ?= $(exec_prefix)/bin

.PHONY: all
all::

.PHONY: clean
clean::

.PHONY: install
install:: image-garden-proxy acng.conf $(if $(DESTDIR),| $(DESTDIR))
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -t $(DESTDIR)$(bindir) image-garden-proxy
	install -m 755 -d $(DESTDIR)$(sysconfdir)
	install -m 755 -d $(DESTDIR)$(sysconfdir)/apt-cacher-ng
	install -m 644 -t $(DESTDIR)$(sysconfdir)/apt-cacher-ng acng.conf

ifneq (,$(DESTDIR))
$(DESTDIR):
	mkdir -p $(DESTDIR)
endif

.PHONY: check
check: SHELLCHECK ?= $(or $(shell command -v shellcheck),$(error program shellcheck is required))
check: image-garden-proxy
	$(SHELLCHECK) $^

.PHONY: fmt
fmt: SHFMT ?= $(or $(shell command -v shfmt),$(error program shfmt is required))
fmt: image-garden-proxy
	$(SHFMT) -w $^

=== qemu-stubs/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki
DESTDIR ?=

prefix ?= /usr/local
exec_prefix ?= $(prefix)
bindir ?= $(exec_prefix)/bin
snapdir ?= /snap

STUBS = qemu-system-x86_64 qemu-system-aarch64 qemu-system-riscv64 qemu-system-s390x qemu-system-ppc64
.PHONY: all
all::

.PHONY: clean
clean::

.PHONY: install
install:: $(STUBS) qemu-component-symlinks $(if $(DESTDIR),| $(DESTDIR))
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -t $(DESTDIR)$(bindir) $(STUBS) qemu-component-symlinks qemu-var-tmp

ifneq (,$(DESTDIR))
$(DESTDIR):
	mkdir -p $(DESTDIR)
endif

.PHONY: check
check: SHELLCHECK ?= $(or $(shell command -v shellcheck),$(error program shellcheck is required))
check: $(STUBS) qemu-component-symlinks qemu-var-tmp
	$(SHELLCHECK) $^

.PHONY: fmt
fmt: SHFMT ?= $(or $(shell command -v shfmt),$(error program shfmt is required))
fmt: $(STUBS) qemu-component-symlinks qemu-var-tmp
	$(SHFMT) -w $^

=== spread-chooser/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki
DESTDIR ?=

prefix ?= /usr/local
exec_prefix ?= $(prefix)
bindir ?= $(exec_prefix)/bin

.PHONY: all
all::

.PHONY: clean
clean::

.PHONY: install
install:: spread-chooser configure $(if $(DESTDIR),| $(DESTDIR))
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -t $(DESTDIR)$(bindir) spread-chooser

ifneq (,$(DESTDIR))
$(DESTDIR):
	mkdir -p $(DESTDIR)
endif

.PHONY: check
check: SHELLCHECK ?= $(or $(shell command -v shellcheck),$(error program shellcheck is required))
check: spread-chooser configure
	$(SHELLCHECK) $^

.PHONY: fmt
fmt: SHFMT ?= $(or $(shell command -v shfmt),$(error program shfmt is required))
fmt: spread-chooser configure
	$(SHFMT) -w $^

=== spread-demo/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: Zygmunt Krynicki

SYSTEMS = $(subst -plus-,+,$(sort $(shell spread -list :tests/smoke/uname | cut -d : -f 2)))

.PHONY:
$(foreach s,$(filter-out gentoo-cloud,$(SYSTEMS)),spread-$s): spread-%:
	$(strip spread $(if $(filter-out oracle-cloud-7 ubuntu-cloud-14.04,$*),-artifacts artifacts) garden:$(subst +,-plus-,$*):)

.PHONY:
spread-gentoo-cloud:
	@echo "Spread cannot connect to sshd 10 in gentoo"
	@echo "See: https://github.com/canonical/spread/issues/243"

.PHONY:
check: $(foreach s,$(SYSTEMS),spread-$s)

=== debian/changelog ===
image-garden (0.4.2-3) unstable; urgency=medium

  * Depend on qemu-efi-riscv64

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 26 Jan 2026 09:51:46 +0000

image-garden (0.4.2-2) unstable; urgency=medium

  * Depend on xorriso, drop genisoimage

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 26 Jan 2026 09:40:58 +0000

image-garden (0.4.2-1) unstable; urgency=medium

  * Depend on xz-utils for xz-compressed images
  * New upstream version 0.4.2
  * Build-depend on mypy and python3

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 26 Jan 2026 09:29:34 +0000

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,22 @@
 Vcs-Browser: https://salsa.debian.org/zyga-guest/image-garden
 Vcs-Git: https://salsa.debian.org/zyga-guest/image-garden.git
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13), shellcheck
+Build-Depends: debhelper-compat (= 13), mypy, python3, shellcheck
 
 Package: image-garden
 Architecture: all
 Depends: ca-certificates,
-         genisoimage,
          make,
          ovmf,
          qemu-efi-aarch64,
+         qemu-efi-riscv64,
          qemu-system-arm,
          qemu-system-x86,
          qemu-utils,
          wget,
          whois,
+         xorriso,
+         xz-utils,
          ${misc:Depends},
          ${shlibs:Depends}
 Description: tool for creating test virtual machines
